<?php

// EXEMPLE de Template 
// LudiKreation
// Par Franck Pertegas
// http://www.ludikreation.com
// http://blog.ludikreation.com

// Appel et affichage du template
// $require = chemin vers le template
function getContent($require){
	
	// démarrage du buffer
	ob_start();
	
	// Verification si le fichier existe
	if(file_exists($require))
		require($require);
	else
		echo 'ERROR : TEMPLATE INTROUVABLE !!!';
	
	// copie du contenu du tampon dans une variable
	$out = ob_get_contents();
	
	// effacement du contenu du tampon et arret de son fonctionnement
	ob_end_clean();
	
	// Recherche d'élément a remplacer
	$out = preg_replace_callback('#\{(.*)~(.*)\}#U', 'callbackBuff', $out);
	
	// Retour
	echo $out;
	
}

// Le callback
function callbackBuff($matches){
	
	// ELEMENTS : $matches[0](tout) - $matches[1](premiere partie) $matches[2](deuxieme partie)
	
	// Pour l'instant seules les zones et les contenus sont traitées
	if($matches[1] == 'ZONE')
		return buffZone($matches[2]);
	if($matches[1] == 'VAR')
		return buffVar($matches[2]);
	else
		return $matches[0];
	
}

// Affichage d'une zone
function buffZone($zone){
		
	// Le chemin vars le fichier
	$file_zone = 'zones/'.strtolower($zone).'.php';
	
	// démarrage du buffer
	ob_start();
	
	// Chargement de la zone
	if(file_exists($file_zone))
		require($file_zone);
	else
		echo '';
	
	// copie du contenu du tampon dans une variable
	$out = ob_get_contents();
	
	// effacement du contenu du tampon et arret de son fonctionnement
	ob_end_clean();
	
	// traitement de la chaine obtenue
	$out = preg_replace_callback('#\{(.*)~(.*)\}#U', 'callbackBuff', $out);
	
	// Sortie
	return $out;
		
}

// Affichage d'une variable
function buffVar($var){
		
	require('var.php');
	
	// démarrage du buffer
	ob_start();
	
	// Chargement de la zone
	if(isset($$var))
		echo $$var;
	else
		echo '';
	
	// copie du contenu du tampon dans une variable
	$out = ob_get_contents();
	
	// effacement du contenu du tampon et arret de son fonctionnement
	ob_end_clean();
	
	// traitement de la chaine obtenue
	$out = preg_replace_callback('#\{(.*)~(.*)\}#U', 'callbackBuff', $out);
	
	// Sortie
	return $out;
		
}

?>